# GoogleEarthEnterpriseTerrainProvider

#### new Cesium.GoogleEarthEnterpriseTerrainProvider(options)
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 99

To construct a GoogleEarthEnterpriseTerrainProvider, call `GoogleEarthEnterpriseTerrainProvider.fromMetadata`. Do not call the constructor directly.
Provides tiled terrain using the Google Earth Enterprise REST API.

Name | Type | Description
--- | --- | ---
`options` | GoogleEarthEnterpriseTerrainProvider.ConstructorOptions | optional An object describing initialization options

##### Example:

    const geeMetadata = await GoogleEarthEnterpriseMetadata.fromUrl("http://www.example.com");
    const gee = Cesium.GoogleEarthEnterpriseTerrainProvider.fromMetadata(geeMetadata);

##### See:

- GoogleEarthEnterpriseTerrainProvider.fromMetadata
- GoogleEarthEnterpriseMetadata.fromUrl
- GoogleEarthEnterpriseImageryProvider
- CesiumTerrainProvider
- Cross-Origin Resource Sharing

### Members

#### readonly availability : TileAvailability
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 228

Gets an object that can be used to determine availability of terrain from this provider, such as at points and in rectangles. This property may be undefined if availability information is not available.

#### readonly credit : Credit
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 188

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain.

#### readonly errorEvent : Event
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 175

Gets an event that is raised when the imagery provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasVertexNormals : boolean
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 214

Gets a value indicating whether or not the requested tiles include vertex normals.

#### readonly hasWaterMask : boolean
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 202

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves.

#### readonly proxy : Proxy
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 149

Gets the proxy used by this provider.

#### readonly tilingScheme : TilingScheme
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 161

Gets the tiling scheme used by this provider.

#### readonly url : string
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 137

Gets the name of the Google Earth Enterprise server url hosting the imagery.

### Methods

#### static Cesium.GoogleEarthEnterpriseTerrainProvider.fromMetadata(metadata, options) → GoogleEarthEnterpriseTerrainProvider
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 250

Creates a GoogleEarthTerrainProvider from GoogleEarthEnterpriseMetadata

Name | Type | Description
--- | --- | ---
`metadata` | GoogleEarthEnterpriseMetadata | A metadata object that can be used to share metadata requests with a GoogleEarthEnterpriseImageryProvider.
`options` | GoogleEarthEnterpriseTerrainProvider.ConstructorOptions | An object describing initialization options

##### Returns:

##### Throws:

- RuntimeError : metadata does not specify terrain

##### Example:

    const geeMetadata = await GoogleEarthEnterpriseMetadata.fromUrl("http://www.example.com");
    const gee = Cesium.GoogleEarthEnterpriseTerrainProvider.fromMetadata(geeMetadata);

##### See:

- GoogleEarthEnterpriseMetadata.fromUrl

#### getLevelMaximumGeometricError(level) → number
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 489

Gets the maximum geometric error allowed in a tile at a given level.

Name | Type | Description
--- | --- | ---
`level` | number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → boolean|undefined
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 503

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 560

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.

##### Returns:

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 301

Requests the geometry for a given tile. The result must include terrain data and may optionally include a water mask and an indication of which child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.

### Type Definitions

#### Cesium.GoogleEarthEnterpriseTerrainProvider.ConstructorOptions
engine/Source/Core/GoogleEarthEnterpriseTerrainProvider.js 67

Initialization options for GoogleEarthEnterpriseTerrainProvider constructor

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`ellipsoid` | Ellipsoid | <optional> | The ellipsoid. If not specified, the WGS84 ellipsoid is used.
`credit` | Credit | string | <optional> | A credit for the data source, which is displayed on the canvas.

Need help? The fastest way to get answers is from the community and team on the Cesium Forum.